# -*- coding: utf_8 -*-
from __future__ import with_statement
print "b1082"
os.chdir("/home/slabbe/.sage/sage_notebook/worksheets/admin/12/cells/0")
sage.server.notebook.interact.SAGE_CELL_ID=0
def inv(a):
    """
    An involution exchanging the sign of an integer and swapping the case of a str.
    """
    if isinstance(a,(int,Integer)):
        if a == Integer(0):
            return oo
        else:
            return -a
    elif a is infinity:
        return Integer(0)
    elif isinstance(a,str) and a.isalpha():
        return a.swapcase()
    else:
        raise TypeError

def chevauche(lena, lenb, d=Integer(0), eq=['a','b'], involution=None):
    """
    Creates two words of length lena and of length lenb respectively.
    Returns the colored vectors represented by the eq with delay d.
    """
    n = lena+lenb
    W = Words(range(-n,n+Integer(1))+[oo])
    im_a = W(range(lena))
    im_b = W(range(lena,n))
    if involution == 'reverse':
        rim_a = W(map(inv, im_a)[::-Integer(1)])
        rim_b = W(map(inv, im_b)[::-Integer(1)])
    elif involution == 'identity':
        rim_a = im_a[::-Integer(1)]
        rim_b = im_b[::-Integer(1)]
    else:
        raise TypeError
    m = WordMorphism({'a':im_a,'b':im_b, 'A':rim_a, 'B':rim_b})

    haut = m(eq[Integer(0)])
    bas = m(eq[Integer(1)])
    p = haut.overlap_partition(bas,d)
    newA = im_a.relabeling(p)
    newB = im_b.relabeling(p)
    rnewA = rim_a.relabeling(p)
    rnewB = rim_b.relabeling(p)

    #print 'a =',str(newA)[6:]
    #print 'b =',str(newB)[6:]
    #print 'A =',str(rnewA)[6:]
    #print 'B =',str(rnewB)[6:]
    alphabet = set(newA * newB * rnewB * rnewA)

    newm = WordMorphism({'a':newA,'b':newB, 'A':rnewA, 'B':rnewB})
    Haut = map(newm, list(eq[Integer(0)]) )
    Bas = map(newm, list(eq[Integer(1)]) )

    rep = vecteurs(Haut,Integer(0),RealNumber('0.1'), len(haut), Integer(1))
    rep += vecteurs(Bas,d,-RealNumber('1.1'), len(bas), Integer(1))

    return rep

def vecteurs(words, x, y, w, h):
    """
    Returns a colored vector of a list of words.

    INPUT:
        words -- list of words
        x,y   -- coordinates of the bottom left of the vector
        w,h   -- the width and the heigth of the vector
    """
    n = sum(map(len, words))
    base =Integer(0) if n==Integer(0) else w / float(n)
    xpos = x
    rep = Graphics()
    for word in words:
        l = len(word)*base
        rep += word.color_vector(xpos, y, l , h, thickness=Integer(2))
        xpos += l
    return rep

print "e1082"
